	!dp = $0000
	!addr = $0000
    !rom = $800000
	!sa1 = 0
	!gsu = 0
    !sram7000 = $000000
    !sram7008 = $000000
    !ram7F9A7B = $000000
    !ram7FC700 = $000000

if read1($00FFD6) == $15
	sfxrom
	!dp = $6000
	!addr = !dp
	!gsu = 1
elseif read1($00FFD5) == $23
	sa1rom
	!dp = $3000
	!addr = $6000
	!sa1 = 1
    !rom = $000000
    !sram7000 = $2E4000
    !sram7008 = $2E6800
    !ram7F9A7B = $3E127B
    !ram7FC700 = $3DFF00
endif

;########################################
;######## Scratchs Rams [$00,$0F] #######
;########################################
!Scratch0 = $00
!Scratch1 = $01
!Scratch2 = $02
!Scratch3 = $03
!Scratch4 = $04
!Scratch5 = $05
!Scratch6 = $06
!Scratch7 = $07
!Scratch8 = $08
!Scratch9 = $09
!ScratchA = $0A
!ScratchB = $0B
!ScratchC = $0C
!ScratchD = $0D
!ScratchE = $0E
!ScratchF = $0F

;########################################
;############## Counters ################
;########################################
!TrueFrameCounter = $13
!EffectiveFrameCounter = $14

;########################################
;############## Control #################
;########################################
!ButtonPressed_BYETUDLR = $15
!ButtonDown_BYETUDLR = $16
!ButtonPressed_AXLR0000 = $17
!ButtonDown_AXLR0000 = $18

;########################################
;############## Layers ##################
;########################################
!Layer1X = $1A
!Layer1Y = $1C
!Layer2X = $1E
!Layer2Y = $20
!Layer3X = $22
!Layer3Y = $24

;########################################
;############## Player ##################
;########################################
!PlayerX = $94
!PlayerY = $96
!PlayerXSpeed = $7B
!PlayerYSpeed = $7D
!PowerUp = $19
!Lives = $0DBE|!addr
!Coins = $0DBF|!addr
!ItemBox = $0DC2|!addr
!PlayerInAirFlag = $72
!PlayerDuckingFlag = $73
!PlayerClimbingFlag_N00SIFHB = $74
!PlayerWaterFlag = $75
!PlayerDirection = $76
!PlayerBlockedStatus_S00MUDLR = $77
!PlayerHide_DLUCAPLU = $78
!CurrentPlayer = $0DB3|!addr
!CapeImage = $13DF|!addr
!PlayerPose = $13E0|!addr
!PlayerSlope = $13E1|!addr
!SpinjumpTimer = $13E2|!addr
!PlayerWallRunningFlag = $13E3|!addr
!PlayerFrozenFlag = $13FB|!addr
!PlayerCarryingFlag = $1470|!addr
!PlayerCarryingFlagImage = $148F|!addr
!PlayerAnimationTimer = $1496|!addr
!PlayerFlashingTimer = $1497|!addr
!P1PowerUp = $0DB8|!addr
!P2PowerUp = $0DB9|!addr
!P1Lives = $0DB4|!addr
!P2Lives = $0DB5|!addr
!P1Coins = $0DB6|!addr
!P2Coins = $0DB7|!addr
!P1YoshiColor = $0DBA|!addr
!P2YoshiColor = $0DBB|!addr
!P1ItemBox = $0DBC|!addr
!P2ItemBox = $0DBD|!addr

;########################################
;############### Global #################
;########################################
!LockAnimationFlag = $9D
!HScrollEnable = $1411|!addr
!VScrollEnable = $1412|!addr
!HScrollLayer2Type = $1413|!addr
!VScrollLayer2Type = $1414|!addr
!WaterFlag = $85
!SlipperyFlag = $86
!GameMode = $0100|!addr
!TwoPlayersFlag = $0DB2|!addr

;########################################
;################ OAM ###################
;########################################
!TileXPosition200 = $0200|!addr
!TileYPosition200 = $0201|!addr
!TileCode200 = $0202|!addr
!TileProperty200 = $0203|!addr
!TileSize420 = $0420|!addr
!TileXPosition = $0300|!addr
!TileYPosition = $0301|!addr
!TileCode = $0302|!addr
!TileProperty = $0303|!addr
!TileSize460 = $0460|!addr

;########################################
;############### Yoshi ##################
;########################################
!YoshiX = $18B0|!addr
!YoshiY = $18B2|!addr
!YoshiKeyInMouthFlag = $191C|!addr

;########################################
;############## Clusters ################
;########################################
!ClusterNumber = $1892|!addr
!ClusterXLow = $1E16|!addr
!ClusterYLow = $1E02|!addr
!ClusterXHigh = $1E3E|!addr
!ClusterYHigh = $1E2A|!addr
!ClusterMiscTable1 = $0F4A|!addr
!ClusterMiscTable2 = $0F5E|!addr
!ClusterMiscTable3 = $0F72|!addr
!ClusterMiscTable4 = $0F86|!addr
!ClusterMiscTable5 = $0F9A|!addr
!ClusterMiscTable6 = $1E52|!addr
!ClusterMiscTable7 = $1E66|!addr
!ClusterMiscTable8 = $1E7A|!addr
!ClusterMiscTable9 = $1E8E|!addr

;########################################
;############## Extended ################
;########################################
!ExtendedNumber = $170B|!addr
!ExtendedXLow = $171F|!addr
!ExtendedYLow = $1715|!addr
!ExtendedXHigh = $1733|!addr
!ExtendedYHigh = $1729|!addr
!ExtendedXSpeed = $1747|!addr
!ExtendedYSpeed = $173D|!addr
!ExtendedXSpeedAccumulatingFraction = $175B|!addr
!ExtendedYSpeedAccumulatingFraction = $1751|!addr
!ExtendedBehindLayersFlag = $1779|!addr
!ExtendedMiscTable1 = $1765|!addr
!ExtendedMiscTable2 = $176F|!addr

;########################################
;############### Sprites ################
;########################################
!SpriteIndex = $15E9|!addr
!SpriteNumber = $9E
!SpriteStatus = $14C8
!SpriteXLow = $E4
!SpriteYLow = $D8
!SpriteXHigh = $14E0
!SpriteYHigh = $14D4
!SpriteXSpeed = $B6
!SpriteYSpeed = $AA
!SpriteXSpeedAccumulatingFraction = $14F8
!SpriteYSpeedAccumulatingFraction = $14EC
!SpriteDirection = $157C
!SpriteBlockedStatus_ASB0UDLR = $1588
!SpriteHOffScreenFlag = $15A0
!SpriteVOffScreenFlag = $186C
!SpriteHMoreThan4TilesOffScreenFlag = $15C4
!SpriteSlope = $15B8
!SpriteYoshiTongueFlag = $15D0
!SpriteInteractionWithObjectEnable = $15DC
!SpriteIndexOAM = $15EA
!SpriteProperties_YXPPCCCT = $15F6
!SpriteLoadStatus = $161A
!SpriteBehindEscenaryFlag = $1632
!SpriteInLiquidFlag = $164A
!SpriteDecTimer1 = $1540
!SpriteDecTimer2 = $154C
!SpriteDecTimer3 = $1558
!SpriteDecTimer4 = $1564
!SpriteDecTimer5 = $15AC
!SpriteDecTimer6 = $163E
!SpriteDecTimer7 = $1FE2
!SpriteTweaker1656_SSJJCCCC = $1656
!SpriteTweaker1662_DSCCCCCC = $1662
!SpriteTweaker166E_LWCFPPPG = $166E
!SpriteTweaker167A_DPMKSPIS = $167A
!SpriteTweaker1686_DNCTSWYE = $1686
!SpriteTweaker190F_WCDJ5SDP = $190F
!SpriteMiscTable1 = $0DF5|!addr
!SpriteMiscTable2 = $0E0B|!addr
!SpriteMiscTable3 = $C2
!SpriteMiscTable4 = $1504
!SpriteMiscTable5 = $1510
!SpriteMiscTable6 = $151C
!SpriteMiscTable7 = $1528
!SpriteMiscTable8 = $1534
!SpriteMiscTable9 = $1570
!SpriteMiscTable10 = $1594
!SpriteMiscTable11 = $1602
!SpriteMiscTable12 = $160E
!SpriteMiscTable13 = $1626
!SpriteMiscTable14 = $187B
!SpriteMiscTable15 = $1FD6

;########################################
;############### GIEPY ##################
;########################################
!ExtraBits = $7FAB10
!NewCodeFlag = $7FAB1C
!ExtraProp1 = $7FAB28
!ExtraProp2 = $7FAB34
!ExtraByte1 = $7FAB40
!ExtraByte2 = $7FAB4C
!ExtraByte3 = $7FAB58
!ExtraByte4 = $7FAB64
!ShooterExtraByte = $7FAB70
!GeneratorExtraByte = $7FAB78
!ScrollerExtraByte = $7FAB79
!CustomSpriteNumber = $7FAB9E
!ShooterExtraBits = $7FABAA
!GeneratorExtraBits = $7FABB2
!Layer1ExtraBits = $7FABB3
!Layer2ExtraBits = $7FABB4
!SpriteFlags = $7FABB5

if !sa1

!SpriteNumber = $3200
!SpriteYSpeed = $9E
!SpriteXSpeed = $B6
!SpriteMiscTable3 = $D8
!SpriteYLow = $3216
!SpriteXLow = $322C
!SpriteStatus = $3242
!SpriteYHigh = $3258
!SpriteXHigh = $326E
!SpriteYSpeedAccumulatingFraction = $74C8
!SpriteXSpeedAccumulatingFraction = $74DE
!SpriteMiscTable4 = $74F4
!SpriteMiscTable5 = $750A
!SpriteMiscTable6 = $3284
!SpriteMiscTable7 = $329A
!SpriteMiscTable8 = $32B0
!SpriteDecTimer1 = $32C6
!SpriteDecTimer2 = $32DC
!SpriteDecTimer3 = $32F2
!SpriteDecTimer4 = $3308
!SpriteMiscTable9 = $331E
!SpriteDirection = $3334
!SpriteBlockedStatus_ASB0UDLR = $334A
!SpriteMiscTable10 = $3360
!SpriteHOffScreenFlag = $3376
!SpriteDecTimer5 = $338C
!SpriteSlope = $7520
!SpriteHMoreThan4TilesOffScreenFlag = $7536
!SpriteYoshiTongueFlag = $754C
!SpriteInteractionWithObjectEnable = $7562
!SpriteIndexOAM = $33A2
!SpriteProperties_YXPPCCCT = $33B8
!SpriteMiscTable11 = $33CE
!SpriteMiscTable12 = $33E4
!SpriteLoadStatus = $7578
!SpriteMiscTable13 = $758E
!SpriteBehindEscenaryFlag = $75A4
!SpriteDecTimer6 = $33FA
!SpriteInLiquidFlag = $75BA
!SpriteTweaker1656_SSJJCCCC = $75D0
!SpriteTweaker1662_DSCCCCCC = $75EA
!SpriteTweaker166E_LWCFPPPG = $7600
!SpriteTweaker167A_DPMKSPIS = $7616
!SpriteTweaker1686_DNCTSWYE = $762C
!SpriteVOffScreenFlag = $7642
!SpriteMiscTable14 = $3410
!SpriteTweaker190F_WCDJ5SDP = $7658
!SpriteMiscTable15 = $766E
!SpriteDecTimer7 = $7FD6

!ExtraBits = $400040
!NewCodeFlag = $400056
!ExtraProp1 = $400057
!ExtraProp2 = $40006D
!ExtraByte1 = $4000A4
!ExtraByte2 = $4000BA
!ExtraByte3 = $4000D0
!ExtraByte4 = $4000E6
!ShooterExtraByte = $400110
!GeneratorExtraByte = $4000FC
!ScrollerExtraByte = $4000FD
!CustomSpriteNumber = $400083
!ShooterExtraBits = $400099
!GeneratorExtraBits = $4000A1
!Layer1ExtraBits = $4000A2
!Layer2ExtraBits = $4000A3
!SpriteFlags = $400118

endif 

;######################################
;############## Defines ###############
;######################################

!FrameIndex = !SpriteMiscTable1
!AnimationTimer = !SpriteDecTimer1
!AnimationIndex = !SpriteMiscTable2
!AnimationFrameIndex = !SpriteMiscTable3
!LocalFlip = !SpriteMiscTable4
!GlobalFlip = !SpriteMiscTable5
!State = !SpriteMiscTable8

;######################################
;########### Init Routine #############
;######################################
print "INIT ",pc
	LDA #$00
	STA !GlobalFlip,x
	JSL InitWrapperChangeAnimationFromStart
    ;Here you can write your Init Code
    ;This will be excecuted when the sprite is spawned 
RTL

;######################################
;########## Main Routine ##############
;######################################
print "MAIN ",pc
    PHB
    PHK
    PLB
    JSR SpriteCode
    PLB
RTL

;>Routine: SpriteCode
;>Description: This routine excecute the logic of the sprite
;>RoutineLength: Short
Return:

SpriteInit:
STZ !State,x ;!State,x = 0

RTS
SpriteCode:

    JSR GraphicRoutine                  ;Calls the graphic routine and updates sprite graphics

    ;Here you can put code that will be excecuted each frame even if the sprite is locked

    LDA !SpriteStatus,x			        
	CMP #$08                            ;if sprite dead return
	BNE Return	

	LDA !LockAnimationFlag				    
	BNE Return			                    ;if locked animation return.

!WalkSpeed = $F2

Walk:
		LDA !1588,x		;load sprite blocked status flag
		AND #$03		;check if blocked on left or right (touching a wall)
		BEQ +			;if not touching, skip ahead.

		LDA #$00 : STA !GlobalFlip,x
		LDA !157C,x		;load sprite direction
		EOR #$01		;flip bit 0 to change direction
		STA !157C,x		;store result back.

+
		LDA #!WalkSpeed		;load speed value
		PHA			;preserve onto stack

		LDA !157C,x		;load sprite direction
		BNE Left		;if facing left, make it move left.

		PLA			;restore speed value from stack
		BRA StoreSpd		;branch to store speed.

Left:
		LDA #$01 : STA !GlobalFlip,x
		PLA			;restore speed value from stack
		EOR #$FF		;invert all bits
		INC A			;increment result by one to get correct negative value
StoreSpd:
		STA !B6,x		;store to sprite's X speed.
		JSL $01802A|!BankB	;update sprite positions based on speeds (apply gravity/object interaction).

    JSL SubOffScreen
	%SubOffScreen()

    JSR InteractMarioSprite
    ;After this routine, if the sprite interact with mario, Carry is Set.

    ;Here you can write your sprite code routine
    ;This will be excecuted once per frame excepts when 
    ;the animation is locked or when sprite status is not #$08

    JSR AnimationRoutine                ;Calls animation routine and decides the next frame to draw
    
    RTS



;>EndRoutine

;######################################
;######## Sub Routine Space ###########
;######################################

;Here you can write routines or tables

;Don't Delete or write another >Section Graphics or >End Section
;All code between >Section Graphics and >End Graphics Section will be changed by Dyzen : Sprite Maker
;>Section Graphics
;######################################
;########## Graphics Space ############
;######################################

;This space is for routines used for graphics
;if you don't know enough about asm then
;don't edit them.

;>Routine: GraphicRoutine
;>Description: Updates tiles on the oam map
;results will be visible the next frame.
;>RoutineLength: Short
GraphicRoutine:

    JSL GetDrawInfo                     ;Calls GetDrawInfo to get the free slot and the XDisp and YDisp
	%GetDrawInfo()

    STZ !Scratch3                       ;$02 = Free Slot but in 16bits
    STY !Scratch2


    STZ !Scratch5
    LDA !GlobalFlip,x   
    STA !ScratchF
    ASL
    STA !Scratch4                       ;$04 = Global Flip but in 16bits
    LDA !ScratchF
    CLC
    ROR A
    ROR A 
    ROR A
    STA !ScratchF


    PHX                                 ;Preserve X
    
    STZ !Scratch7
    LDA !FrameIndex,x
    STA !Scratch6                       ;$06 = Frame Index but in 16bits

    REP #$30                            ;A/X/Y 16bits mode
    LDY !Scratch4                       ;Y = Global Flip
    LDA !Scratch6
    ASL
	CLC
    ADC FramesFlippers,y
    TAX                                 ;X = Frame Index

    LDA FramesLength,x
    CMP #$FFFF
    BNE +
    SEP #$30
    PLX
    RTS
+
    STA !Scratch8

    LDA FramesEndPosition,x
    STA !Scratch4                       ;$04 = End Position + A value used to select a frame version that is flipped

    LDA FramesStartPosition,x           
    TAX                                 ;X = Start Position
    SEP #$20                            ;A 8bits mode
    LDY !Scratch2                       ;Y = Free Slot
    CPY #$00FD
    BCS .return                         ;Y can't be more than #$00FD
-
    LDA Tiles,x
    STA !TileCode,y                     ;Set the Tile code of the tile Y

	LDA #$2F
    EOR !ScratchF
    STA !TileProperty,y                 ;Set the Tile property of the tile Y

    LDA !Scratch0
	CLC
	ADC XDisplacements,x
	STA !TileXPosition,y                ;Set the Tile x pos of the tile Y

    LDA !Scratch1
	CLC
	ADC YDisplacements,x
	STA !TileYPosition,y                ;Set the Tile y pos of the tile Y

    PHY
	REP #$20                                 
    TYA
    LSR
    LSR
    TAY                                 ;Y = Y/4 because size directions are not continuous to map 200 and 300
	SEP #$20
    LDA Sizes,x
    STA !TileSize460,y                  ;Set the Tile size of the tile Y
    PLY

    INY
    INY
    INY
    INY                                 ;Next OAM Slot
    CPY #$00FD
    BCS .return                         ;Y can't be more than #$00FD

    DEX
    BMI .return
    CPX !Scratch4                       ;if X < start position or is negative then return
    BCS -                               ;else loop

.return
    SEP #$10
    PLX                                 ;Restore X
    
    LDY #$FF                            ;Allows mode of 8 or 16 bits
    LDA !Scratch8                       ;Load the number of tiles used by the frame
    JSL $01B7B3|!rom                  		;This insert the new tiles into the oam, 
                                        ;A = #$00 => only tiles of 8x8, A = #$02 = only tiles of 16x16, A = #$04 = tiles of 8x8 or 16x16
                                        ;if you select A = #$04 then you must put the sizes of the tiles in !TileSize
RTS
;>EndRoutine

;All words that starts with '@' and finish with '.' will be replaced by Dyzen

;>Table: FramesLengths
;>Description: How many tiles use each frame.
;>ValuesSize: 16
FramesLength:
    dw $0008,$0008,$0008,$0008,$000C,$000C,$000C,$000C,$0010,$0010,$0010,$0010,$0014,$0014,$0014,$0014
	dw $0008,$0008,$0008,$0008,$000C,$000C,$000C,$000C,$0010,$0010,$0010,$0010,$0014,$0014,$0014,$0014
;>EndTable


;>Table: FramesFlippers
;>Description: Values used to add values to FramesStartPosition and FramesEndPosition
;To use a flipped version of the frames.
;>ValuesSize: 16
FramesFlippers:
    dw $0000,$0020
;>EndTable


;>Table: FramesStartPosition
;>Description: Indicates the index where starts each frame
;>ValuesSize: 16
FramesStartPosition:
    dw $0008,$0011,$001A,$0023,$0030,$003D,$004A,$0057,$0068,$0079,$008A,$009B,$00B0,$00C5,$00DA,$00EF
	dw $00F8,$0101,$010A,$0113,$0120,$012D,$013A,$0147,$0158,$0169,$017A,$018B,$01A0,$01B5,$01CA,$01DF
;>EndTable

;>Table: FramesEndPosition
;>Description: Indicates the index where end each frame
;>ValuesSize: 16
FramesEndPosition:
    dw $0000,$0009,$0012,$001B,$0024,$0031,$003E,$004B,$0058,$0069,$007A,$008B,$009C,$00B1,$00C6,$00DB
	dw $00F0,$00F9,$0102,$010B,$0114,$0121,$012E,$013B,$0148,$0159,$016A,$017B,$018C,$01A1,$01B6,$01CB
;>EndTable


;>Table: Tiles
;>Description: Tiles codes of each tile of each frame
;>ValuesSize: 8
Tiles:
    
Frame0_Move1_Tiles:
	db $80,$90,$81,$91,$E6,$E7,$E8,$E0,$E1
Frame1_Move2_Tiles:
	db $83,$93,$84,$94,$E3,$E4,$F6,$F7,$F8
Frame2_Move3_Tiles:
	db $B0,$C0,$B1,$C1,$E0,$E1,$E6,$E7,$E8
Frame3_Move4_Tiles:
	db $B3,$C3,$B4,$C4,$F6,$F7,$F8,$E3,$E4
Frame4_Move5_Tiles:
	db $80,$90,$81,$91,$E6,$E7,$E8,$E0,$E1,$80,$90,$81,$91
Frame5_Move6_Tiles:
	db $83,$93,$84,$94,$E3,$E4,$F6,$F7,$F8,$83,$93,$84,$94
Frame6_Move7_Tiles:
	db $B0,$C0,$B1,$C1,$E0,$E1,$E6,$E7,$E8,$B0,$C0,$B1,$C1
Frame7_Move8_Tiles:
	db $B3,$C3,$B4,$C4,$F6,$F7,$F8,$E3,$E4,$B3,$C3,$B4,$C4
Frame8_Move9_Tiles:
	db $80,$90,$81,$91,$E6,$E7,$E8,$E0,$E1,$80,$90,$81,$91,$80,$90,$81
	db $91
Frame9_Move10_Tiles:
	db $83,$93,$84,$94,$E3,$E4,$F6,$F7,$F8,$83,$93,$84,$94,$83,$93,$84
	db $94
Frame10_Move11_Tiles:
	db $B0,$C0,$B1,$C1,$E0,$E1,$E6,$E7,$E8,$B0,$C0,$B1,$C1,$B0,$C0,$B1
	db $C1
Frame11_Move12_Tiles:
	db $B3,$C3,$B4,$C4,$F6,$F7,$F8,$E3,$E4,$B3,$C3,$B4,$C4,$B3,$C3,$B4
	db $C4
Frame12_Move13_Tiles:
	db $80,$90,$81,$91,$E6,$E7,$E8,$E0,$E1,$80,$90,$81,$91,$80,$90,$81
	db $91,$80,$90,$81,$91
Frame13_Move14_Tiles:
	db $83,$93,$84,$94,$E3,$E4,$F6,$F7,$F8,$83,$93,$84,$94,$83,$93,$84
	db $94,$83,$93,$84,$94
Frame14_Move15_Tiles:
	db $B0,$C0,$B1,$C1,$E0,$E1,$E6,$E7,$E8,$B0,$C0,$B1,$C1,$B0,$C0,$B1
	db $C1,$B0,$C0,$B1,$C1
Frame15_Move16_Tiles:
	db $B3,$C3,$B4,$C4,$F6,$F7,$F8,$E3,$E4,$B3,$C3,$B4,$C4,$B3,$C3,$B4
	db $C4,$B3,$C3,$B4,$C4
Frame0_Move1_TilesFlipX:
	db $80,$90,$81,$91,$E6,$E7,$E8,$E0,$E1
Frame1_Move2_TilesFlipX:
	db $83,$93,$84,$94,$E3,$E4,$F6,$F7,$F8
Frame2_Move3_TilesFlipX:
	db $B0,$C0,$B1,$C1,$E0,$E1,$E6,$E7,$E8
Frame3_Move4_TilesFlipX:
	db $B3,$C3,$B4,$C4,$F6,$F7,$F8,$E3,$E4
Frame4_Move5_TilesFlipX:
	db $80,$90,$81,$91,$E6,$E7,$E8,$E0,$E1,$80,$90,$81,$91
Frame5_Move6_TilesFlipX:
	db $83,$93,$84,$94,$E3,$E4,$F6,$F7,$F8,$83,$93,$84,$94
Frame6_Move7_TilesFlipX:
	db $B0,$C0,$B1,$C1,$E0,$E1,$E6,$E7,$E8,$B0,$C0,$B1,$C1
Frame7_Move8_TilesFlipX:
	db $B3,$C3,$B4,$C4,$F6,$F7,$F8,$E3,$E4,$B3,$C3,$B4,$C4
Frame8_Move9_TilesFlipX:
	db $80,$90,$81,$91,$E6,$E7,$E8,$E0,$E1,$80,$90,$81,$91,$80,$90,$81
	db $91
Frame9_Move10_TilesFlipX:
	db $83,$93,$84,$94,$E3,$E4,$F6,$F7,$F8,$83,$93,$84,$94,$83,$93,$84
	db $94
Frame10_Move11_TilesFlipX:
	db $B0,$C0,$B1,$C1,$E0,$E1,$E6,$E7,$E8,$B0,$C0,$B1,$C1,$B0,$C0,$B1
	db $C1
Frame11_Move12_TilesFlipX:
	db $B3,$C3,$B4,$C4,$F6,$F7,$F8,$E3,$E4,$B3,$C3,$B4,$C4,$B3,$C3,$B4
	db $C4
Frame12_Move13_TilesFlipX:
	db $80,$90,$81,$91,$E6,$E7,$E8,$E0,$E1,$80,$90,$81,$91,$80,$90,$81
	db $91,$80,$90,$81,$91
Frame13_Move14_TilesFlipX:
	db $83,$93,$84,$94,$E3,$E4,$F6,$F7,$F8,$83,$93,$84,$94,$83,$93,$84
	db $94,$83,$93,$84,$94
Frame14_Move15_TilesFlipX:
	db $B0,$C0,$B1,$C1,$E0,$E1,$E6,$E7,$E8,$B0,$C0,$B1,$C1,$B0,$C0,$B1
	db $C1,$B0,$C0,$B1,$C1
Frame15_Move16_TilesFlipX:
	db $B3,$C3,$B4,$C4,$F6,$F7,$F8,$E3,$E4,$B3,$C3,$B4,$C4,$B3,$C3,$B4
	db $C4,$B3,$C3,$B4,$C4
;>EndTable

;>Table: XDisplacements
;>Description: X Displacement of each tile of each frame
;>ValuesSize: 8
XDisplacements:
    
Frame0_Move1_XDisp:
	db $FE,$FE,$06,$06,$FC,$04,$0C,$FC,$04
Frame1_Move2_XDisp:
	db $00,$00,$08,$08,$FC,$04,$FC,$04,$0C
Frame2_Move3_XDisp:
	db $FF,$FF,$07,$07,$FC,$04,$FC,$04,$0C
Frame3_Move4_XDisp:
	db $FE,$FE,$06,$06,$FC,$04,$0C,$FC,$04
Frame4_Move5_XDisp:
	db $FE,$FE,$06,$06,$FC,$04,$0C,$FC,$04,$FE,$FE,$06,$06
Frame5_Move6_XDisp:
	db $00,$00,$08,$08,$FC,$04,$FC,$04,$0C,$00,$00,$08,$08
Frame6_Move7_XDisp:
	db $FF,$FF,$07,$07,$FC,$04,$FC,$04,$0C,$FF,$FF,$07,$07
Frame7_Move8_XDisp:
	db $FE,$FE,$06,$06,$FC,$04,$0C,$FC,$04,$FE,$FE,$06,$06
Frame8_Move9_XDisp:
	db $FE,$FE,$06,$06,$FC,$04,$0C,$FC,$04,$FE,$FE,$06,$06,$FE,$FE,$06
	db $06
Frame9_Move10_XDisp:
	db $00,$00,$08,$08,$FC,$04,$FC,$04,$0C,$00,$00,$08,$08,$00,$00,$08
	db $08
Frame10_Move11_XDisp:
	db $FF,$FF,$07,$07,$FC,$04,$FC,$04,$0C,$FF,$FF,$07,$07,$FF,$FF,$07
	db $07
Frame11_Move12_XDisp:
	db $FE,$FE,$06,$06,$FC,$04,$0C,$FC,$04,$FE,$FE,$06,$06,$FE,$FE,$06
	db $06
Frame12_Move13_XDisp:
	db $FE,$FE,$06,$06,$FC,$04,$0C,$FC,$04,$FE,$FE,$06,$06,$FE,$FE,$06
	db $06,$FE,$FE,$06,$06
Frame13_Move14_XDisp:
	db $00,$00,$08,$08,$FC,$04,$FC,$04,$0C,$00,$00,$08,$08,$00,$00,$08
	db $08,$00,$00,$08,$08
Frame14_Move15_XDisp:
	db $FF,$FF,$07,$07,$FC,$04,$FC,$04,$0C,$FF,$FF,$07,$07,$FF,$FF,$07
	db $07,$FF,$FF,$07,$07
Frame15_Move16_XDisp:
	db $FE,$FE,$06,$06,$FC,$04,$0C,$FC,$04,$FE,$FE,$06,$06,$FE,$FE,$06
	db $06,$FE,$FE,$06,$06
Frame0_Move1_XDispFlipX:
	db $02,$02,$FA,$FA,$0C,$04,$FC,$04,$FC
Frame1_Move2_XDispFlipX:
	db $00,$00,$F8,$F8,$04,$FC,$0C,$04,$FC
Frame2_Move3_XDispFlipX:
	db $01,$01,$F9,$F9,$04,$FC,$0C,$04,$FC
Frame3_Move4_XDispFlipX:
	db $02,$02,$FA,$FA,$0C,$04,$FC,$04,$FC
Frame4_Move5_XDispFlipX:
	db $02,$02,$FA,$FA,$0C,$04,$FC,$04,$FC,$02,$02,$FA,$FA
Frame5_Move6_XDispFlipX:
	db $00,$00,$F8,$F8,$04,$FC,$0C,$04,$FC,$00,$00,$F8,$F8
Frame6_Move7_XDispFlipX:
	db $01,$01,$F9,$F9,$04,$FC,$0C,$04,$FC,$01,$01,$F9,$F9
Frame7_Move8_XDispFlipX:
	db $02,$02,$FA,$FA,$0C,$04,$FC,$04,$FC,$02,$02,$FA,$FA
Frame8_Move9_XDispFlipX:
	db $02,$02,$FA,$FA,$0C,$04,$FC,$04,$FC,$02,$02,$FA,$FA,$02,$02,$FA
	db $FA
Frame9_Move10_XDispFlipX:
	db $00,$00,$F8,$F8,$04,$FC,$0C,$04,$FC,$00,$00,$F8,$F8,$00,$00,$F8
	db $F8
Frame10_Move11_XDispFlipX:
	db $01,$01,$F9,$F9,$04,$FC,$0C,$04,$FC,$01,$01,$F9,$F9,$01,$01,$F9
	db $F9
Frame11_Move12_XDispFlipX:
	db $02,$02,$FA,$FA,$0C,$04,$FC,$04,$FC,$02,$02,$FA,$FA,$02,$02,$FA
	db $FA
Frame12_Move13_XDispFlipX:
	db $02,$02,$FA,$FA,$0C,$04,$FC,$04,$FC,$02,$02,$FA,$FA,$02,$02,$FA
	db $FA,$02,$02,$FA,$FA
Frame13_Move14_XDispFlipX:
	db $00,$00,$F8,$F8,$04,$FC,$0C,$04,$FC,$00,$00,$F8,$F8,$00,$00,$F8
	db $F8,$00,$00,$F8,$F8
Frame14_Move15_XDispFlipX:
	db $01,$01,$F9,$F9,$04,$FC,$0C,$04,$FC,$01,$01,$F9,$F9,$01,$01,$F9
	db $F9,$01,$01,$F9,$F9
Frame15_Move16_XDispFlipX:
	db $02,$02,$FA,$FA,$0C,$04,$FC,$04,$FC,$02,$02,$FA,$FA,$02,$02,$FA
	db $FA,$02,$02,$FA,$FA
;>EndTable
;>Table: YDisplacements
;>Description: Y Displacement of each tile of each frame
;>ValuesSize: 8
YDisplacements:
    
Frame0_Move1_YDisp:
	db $EA,$F2,$EA,$F2,$0A,$0A,$0A,$FA,$FA
Frame1_Move2_YDisp:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A
Frame2_Move3_YDisp:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A
Frame3_Move4_YDisp:
	db $E8,$F0,$E8,$F0,$0A,$0A,$0A,$FA,$FA
Frame4_Move5_YDisp:
	db $EA,$F2,$EA,$F2,$0A,$0A,$0A,$FA,$FA,$E2,$EA,$E2,$EA
Frame5_Move6_YDisp:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A,$DE,$E6,$DE,$E6
Frame6_Move7_YDisp:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A,$DE,$E6,$DE,$E6
Frame7_Move8_YDisp:
	db $E8,$F0,$E8,$F0,$0A,$0A,$0A,$FA,$FA,$DF,$E7,$DF,$E7
Frame8_Move9_YDisp:
	db $EA,$F2,$EA,$F2,$0A,$0A,$0A,$FA,$FA,$E2,$EA,$E2,$EA,$DA,$E2,$DA
	db $E2
Frame9_Move10_YDisp:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A,$DE,$E6,$DE,$E6,$D4,$DC,$D4
	db $DC
Frame10_Move11_YDisp:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A,$DE,$E6,$DE,$E6,$D4,$DC,$D4
	db $DC
Frame11_Move12_YDisp:
	db $E8,$F0,$E8,$F0,$0A,$0A,$0A,$FA,$FA,$DF,$E7,$DF,$E7,$D6,$DE,$D6
	db $DE
Frame12_Move13_YDisp:
	db $EA,$F2,$EA,$F2,$0A,$0A,$0A,$FA,$FA,$E2,$EA,$E2,$EA,$DA,$E2,$DA
	db $E2,$D2,$DA,$D2,$DA
Frame13_Move14_YDisp:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A,$DE,$E6,$DE,$E6,$D4,$DC,$D4
	db $DC,$CA,$D2,$CA,$D2
Frame14_Move15_YDisp:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A,$DE,$E6,$DE,$E6,$D4,$DC,$D4
	db $DC,$CA,$D2,$CA,$D2
Frame15_Move16_YDisp:
	db $E8,$F0,$E8,$F0,$0A,$0A,$0A,$FA,$FA,$DF,$E7,$DF,$E7,$D6,$DE,$D6
	db $DE,$CD,$D5,$CD,$D5
Frame0_Move1_YDispFlipX:
	db $EA,$F2,$EA,$F2,$0A,$0A,$0A,$FA,$FA
Frame1_Move2_YDispFlipX:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A
Frame2_Move3_YDispFlipX:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A
Frame3_Move4_YDispFlipX:
	db $E8,$F0,$E8,$F0,$0A,$0A,$0A,$FA,$FA
Frame4_Move5_YDispFlipX:
	db $EA,$F2,$EA,$F2,$0A,$0A,$0A,$FA,$FA,$E2,$EA,$E2,$EA
Frame5_Move6_YDispFlipX:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A,$DE,$E6,$DE,$E6
Frame6_Move7_YDispFlipX:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A,$DE,$E6,$DE,$E6
Frame7_Move8_YDispFlipX:
	db $E8,$F0,$E8,$F0,$0A,$0A,$0A,$FA,$FA,$DF,$E7,$DF,$E7
Frame8_Move9_YDispFlipX:
	db $EA,$F2,$EA,$F2,$0A,$0A,$0A,$FA,$FA,$E2,$EA,$E2,$EA,$DA,$E2,$DA
	db $E2
Frame9_Move10_YDispFlipX:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A,$DE,$E6,$DE,$E6,$D4,$DC,$D4
	db $DC
Frame10_Move11_YDispFlipX:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A,$DE,$E6,$DE,$E6,$D4,$DC,$D4
	db $DC
Frame11_Move12_YDispFlipX:
	db $E8,$F0,$E8,$F0,$0A,$0A,$0A,$FA,$FA,$DF,$E7,$DF,$E7,$D6,$DE,$D6
	db $DE
Frame12_Move13_YDispFlipX:
	db $EA,$F2,$EA,$F2,$0A,$0A,$0A,$FA,$FA,$E2,$EA,$E2,$EA,$DA,$E2,$DA
	db $E2,$D2,$DA,$D2,$DA
Frame13_Move14_YDispFlipX:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A,$DE,$E6,$DE,$E6,$D4,$DC,$D4
	db $DC,$CA,$D2,$CA,$D2
Frame14_Move15_YDispFlipX:
	db $E8,$F0,$E8,$F0,$FA,$FA,$0A,$0A,$0A,$DE,$E6,$DE,$E6,$D4,$DC,$D4
	db $DC,$CA,$D2,$CA,$D2
Frame15_Move16_YDispFlipX:
	db $E8,$F0,$E8,$F0,$0A,$0A,$0A,$FA,$FA,$DF,$E7,$DF,$E7,$D6,$DE,$D6
	db $DE,$CD,$D5,$CD,$D5
;>EndTable
;>Table: Sizes.
;>Description: size of each tile of each frame
;>ValuesSize: 8
Sizes:
    
Frame0_Move1_Sizes:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02
Frame1_Move2_Sizes:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00
Frame2_Move3_Sizes:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00
Frame3_Move4_Sizes:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02
Frame4_Move5_Sizes:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02
Frame5_Move6_Sizes:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02
Frame6_Move7_Sizes:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02
Frame7_Move8_Sizes:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02
Frame8_Move9_Sizes:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02,$02,$02
	db $02
Frame9_Move10_Sizes:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02
	db $02
Frame10_Move11_Sizes:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02
	db $02
Frame11_Move12_Sizes:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02,$02,$02
	db $02
Frame12_Move13_Sizes:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02,$02,$02
	db $02,$02,$02,$02,$02
Frame13_Move14_Sizes:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02
	db $02,$02,$02,$02,$02
Frame14_Move15_Sizes:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02
	db $02,$02,$02,$02,$02
Frame15_Move16_Sizes:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02,$02,$02
	db $02,$02,$02,$02,$02
Frame0_Move1_SizesFlipX:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02
Frame1_Move2_SizesFlipX:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00
Frame2_Move3_SizesFlipX:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00
Frame3_Move4_SizesFlipX:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02
Frame4_Move5_SizesFlipX:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02
Frame5_Move6_SizesFlipX:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02
Frame6_Move7_SizesFlipX:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02
Frame7_Move8_SizesFlipX:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02
Frame8_Move9_SizesFlipX:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02,$02,$02
	db $02
Frame9_Move10_SizesFlipX:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02
	db $02
Frame10_Move11_SizesFlipX:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02
	db $02
Frame11_Move12_SizesFlipX:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02,$02,$02
	db $02
Frame12_Move13_SizesFlipX:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02,$02,$02
	db $02,$02,$02,$02,$02
Frame13_Move14_SizesFlipX:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02
	db $02,$02,$02,$02,$02
Frame14_Move15_SizesFlipX:
	db $02,$02,$02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02
	db $02,$02,$02,$02,$02
Frame15_Move16_SizesFlipX:
	db $02,$02,$02,$02,$00,$00,$00,$02,$02,$02,$02,$02,$02,$02,$02,$02
	db $02,$02,$02,$02,$02
;>EndTable

;>End Graphics Section

;Don't Delete or write another >Section Animation or >End Section
;All code between >Section Animations and >End Animations Section will be changed by Dyzen : Sprite Maker
;>Section Animations
;######################################
;########## Animation Space ###########
;######################################

;This space is for routines used for graphics
;if you don't know enough about asm then
;don't edit them.
InitWrapperChangeAnimationFromStart:
	PHB
    PHK
    PLB
	STZ !AnimationIndex,x
	JSR ChangeAnimationFromStart
	PLB
	RTL

ChangeAnimationFromStart_Move:
	STZ !AnimationIndex,x


ChangeAnimationFromStart:
	STZ !AnimationFrameIndex,x

	STZ !Scratch1
	LDA !AnimationIndex,x
	STA !Scratch0					;$00 = Animation index in 16 bits

	STZ !Scratch3
	LDA !AnimationFrameIndex,x
	STA !Scratch2					;$02 = Animation Frame index in 16 bits

	STZ !Scratch5
	STX !Scratch4					;$04 = sprite index in 16 bits

	REP #$30						;A7X/Y of 16 bits
	LDX !Scratch4					;X = sprite index in 16 bits

	LDA !Scratch0
	ASL
	TAY								;Y = 2*Animation index

	LDA !Scratch2
	CLC
	ADC AnimationIndexer,y
	TAY								;Y = Position of the first frame of the animation + animation frame index

	SEP #$20						;A of 8 bits

	LDA Frames,y
	STA !FrameIndex,x				;New Frame = Frames[New Animation Frame Index]

	LDA Times,y
	STA !AnimationTimer,x			;Time = Times[New Animation Frame Index]

	LDA !Scratch2
	STA !AnimationFrameIndex,x

	SEP #$10						;X/Y of 8 bits
	LDX !Scratch4					;X = sprite index in 8 bits
RTS
	

;>Routine: AnimationRoutine
;>Description: Decides what will be the next frame.
;>RoutineLength: Short
AnimationRoutine:
    LDA !AnimationTimer,x
    BEQ +

	RTS

+
	STZ !Scratch1
	LDA !AnimationIndex,x
	STA !Scratch0					;$00 = Animation index in 16 bits

	STZ !Scratch3
	LDA !AnimationFrameIndex,x
	STA !Scratch2					;$02 = Animation Frame index in 16 bits

	STZ !Scratch5
	STX !Scratch4					;$04 = sprite index in 16 bits

	REP #$30						;A7X/Y of 16 bits
	LDX !Scratch4					;X = sprite index in 16 bits

	LDA !Scratch0
	ASL
	TAY								;Y = 2*Animation index

	INC !Scratch2					;New Animation Frame Index = Animation Frame Index + 1

	LDA !Scratch2			        ;if Animation Frame index < Animation Lenght then Animation Frame index++
	CMP AnimationLenght,y			;else go to the frame where start the loop.
	BCC +							

	LDA AnimationLastTransition,y
	STA !Scratch2					;New Animation Frame Index = first frame of the loop.

+
	LDA !Scratch2
	CLC
	ADC AnimationIndexer,y
	TAY								;Y = Position of the first frame of the animation + animation frame index

	SEP #$20						;A of 8 bits

	LDA Frames,y
	STA !FrameIndex,x				;New Frame = Frames[New Animation Frame Index]

	LDA Times,y
	STA !AnimationTimer,x			;Time = Times[New Animation Frame Index]

	LDA !Scratch2
	STA !AnimationFrameIndex,x

	SEP #$10						;X/Y of 8 bits
	LDX !Scratch4					;X = sprite index in 8 bits
RTS
;>EndRoutine

;All words that starts with '>' and finish with '.' will be replaced by Dyzen

AnimationLenght:
	dw $001C

AnimationLastTransition:
	dw $0000

AnimationIndexer:
	dw $0000

Frames:
	
Animation0_Move_Frames:
	db $00,$01,$02,$03,$00,$01,$02,$03,$00,$01,$02,$03,$04,$09,$0E,$0F
	db $0C,$0D,$0E,$0F,$0C,$0D,$0E,$0F,$08,$05,$02,$03

Times:
	
Animation0_Move_Times:
	db $05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05
	db $05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05,$05
;>End Animations Section

;Don't Delete or write another >Section Hitbox Interaction or >End Section
;All code between >Section Hitboxes Interaction and >End Hitboxes Interaction Section will be changed by Dyzen : Sprite Maker
;>Section Hitboxes Interaction
;######################################
;######## Interaction Space ###########
;######################################

InteractMarioSprite:
	LDA !SpriteTweaker167A_DPMKSPIS,x
	AND #$20
	BNE ProcessInteract      
	TXA                       
	EOR !TrueFrameCounter      			
	AND #$01                	
	ORA !SpriteHOffScreenFlag,x 				
	BEQ ProcessInteract       
ReturnNoContact:
	CLC                       
	RTS
ProcessInteract:
	JSL SubHorzPos
	%SubHorzPos()
	LDA !ScratchF                  
	CLC                       
	ADC #$50                
	CMP #$A0                
	BCS ReturnNoContact       ; No contact, return 
	JSL SubVertPos         
	%SubVertPos()
	LDA !ScratchE                   
	CLC                       
	ADC #$60                
	CMP #$C0                
	BCS ReturnNoContact       ; No contact, return 
	LDA $71    ; \ If animation sequence activated... 
	CMP #$01                ;  | 
	BCS ReturnNoContact       ; / ...no contact, return 
	LDA #$00                ; \ Branch if bit 6 of $0D9B set? 
	BIT $0D9B|!addr               ;  | 
	BVS +           ; / 
	LDA $13F9|!addr ; \ If Mario and Sprite not on same side of scenery... 
	EOR !SpriteBehindEscenaryFlag,x ;  |
+
	BNE ReturnNoContact2
	JSL $03B664|!rom				; MarioClipping
	JSR Interaction

	BCC ReturnNoContact2
	LDA !ScratchE
	CMP #$01
	BNE +
	JSR DefaultAction
+
	SEC
	RTS
ReturnNoContact2:
	CLC
	RTS

Interaction:
    STZ !ScratchE
	LDA !GlobalFlip,x
    ASL
	TAY                     ;Y = Flip Adder, used to jump to the frame with the current flip

    LDA !FrameIndex,x
	STA !Scratch4
	STZ !Scratch5

    REP #$20
	LDA !Scratch4
	ASL
	CLC
	ADC HitboxAdder,y
	REP #$10
	TAY

    LDA FrameHitboxesIndexer,y
    TAY
    SEP #$20

-
    LDA FrameHitBoxes,y
    CMP #$FF
    BNE +
    LDA !ScratchE
    BNE ++
	SEP #$10
	LDX !SpriteIndex
    CLC
    RTS
++
	SEP #$10
	LDX !SpriteIndex
    SEC
    RTS
+
    STA !Scratch4
    STZ !Scratch5
    PHY

    REP #$20
    LDA !Scratch4
    ASL
    TAY

    LDA HitboxesStart,y
    TAY
    SEP #$20

	LDA !ScratchE
	AND #$01
	BEQ +

	LDA Hitboxes+5,y
	BNE +

	PLY
    INY
	BRA -

+

	STZ !ScratchA
    LDA Hitboxes+1,y
    STA !Scratch4           ;$04 = Low X Offset
    BPL +
    LDA #$FF
    STA !ScratchA           ;$0A = High X offset
+

	STZ !ScratchB
    LDA Hitboxes+2,y
    STA !Scratch5           ;$05 = Low Y Offset
    BPL +
    LDA #$FF
    STA !ScratchB           ;$0B = High Y Offset
+

    LDA Hitboxes+3,y
    STA !Scratch6           ;$06 = Width

    LDA Hitboxes+4,y
    STA !Scratch7           ;$07 = Height

	PHY
	SEP #$10
	LDX !SpriteIndex

	LDA !SpriteXHigh,x
	XBA
	LDA !SpriteXLow,x
	REP #$20
	PHA
	SEP #$20

	LDA !ScratchA
	XBA
	LDA !Scratch4
	REP #$20
	CLC
	ADC $01,s
	PHA
	SEP #$20
	PLA 
	STA !Scratch4
	PLA
	STA !ScratchA
	PLA
	PLA

	LDA !SpriteYHigh,x
	XBA
	LDA !SpriteYLow,x
	REP #$20
	PHA
	SEP #$20

	LDA !ScratchB
	XBA
	LDA !Scratch5
	REP #$20
	CLC
	ADC $01,s
	PHA
	SEP #$20
	PLA 
	STA !Scratch5
	PLA
	STA !ScratchB
	PLA
	PLA

    JSL $03B72B|!rom
	REP #$10
	BCS ++
	PLY
	BRA +
++
	PLY

    LDA Hitboxes+5,y
	BNE ++

	LDA !ScratchE
	ORA #$01
    STA !ScratchE
	PLY
    INY
    JMP -

++

    STA !ScratchC
    STZ !ScratchD
    REP #$20
    LDA !ScratchC
    ASL
    TAY

    LDA Actions,y
    STA !ScratchC
    SEP #$30
	LDX #$00
    JSR ($000C|!dp,x)
    REP #$10
+
    PLY
    INY
    JMP -


HitboxAdder:
    dw $0000,$0020

FrameHitboxesIndexer:
    dw $0000,$0002,$0004,$0006,$0008,$000A,$000C,$000E,$0010,$0012,$0014,$0016,$0018,$001A,$001C,$001E
	dw $0020,$0022,$0024,$0026,$0028,$002A,$002C,$002E,$0030,$0032,$0034,$0036,$0038,$003A,$003C,$003E

FrameHitBoxes:
    db $00,$FF
	db $00,$FF
	db $00,$FF
	db $00,$FF
	db $01,$FF
	db $02,$FF
	db $03,$FF
	db $04,$FF
	db $05,$FF
	db $06,$FF
	db $07,$FF
	db $08,$FF
	db $09,$FF
	db $0A,$FF
	db $0B,$FF
	db $0C,$FF
	
	db $0D,$FF
	db $0D,$FF
	db $0D,$FF
	db $0D,$FF
	db $0E,$FF
	db $0F,$FF
	db $10,$FF
	db $11,$FF
	db $12,$FF
	db $13,$FF
	db $14,$FF
	db $15,$FF
	db $16,$FF
	db $17,$FF
	db $18,$FF
	db $19,$FF
	

HitboxesStart:
    dw $0000,$0006,$000C,$0012,$0018,$001E,$0024,$002A,$0030,$0036,$003C,$0042,$0048,$004E,$0054,$005A
	dw $0060,$0066,$006C,$0072,$0078,$007E,$0084,$008A,$0090,$0096

Hitboxes:
    db $01,$01,$F1,$10,$21,$01
	db $01,$01,$E9,$10,$29,$01
	db $01,$01,$E5,$10,$2D,$01
	db $01,$01,$E4,$10,$2E,$01
	db $01,$01,$E7,$10,$2B,$01
	db $01,$01,$E1,$10,$31,$01
	db $01,$01,$DB,$10,$37,$01
	db $01,$01,$DA,$10,$38,$01
	db $01,$01,$DE,$10,$34,$01
	db $01,$01,$D9,$10,$39,$01
	db $01,$01,$D1,$10,$41,$01
	db $01,$01,$D0,$10,$42,$01
	db $01,$01,$D5,$10,$3D,$01
	db $01,$FF,$F1,$10,$21,$01
	db $01,$FF,$E9,$10,$29,$01
	db $01,$FF,$E5,$10,$2D,$01
	db $01,$FF,$E4,$10,$2E,$01
	db $01,$FF,$E7,$10,$2B,$01
	db $01,$FF,$E1,$10,$31,$01
	db $01,$FF,$DB,$10,$37,$01
	db $01,$FF,$DA,$10,$38,$01
	db $01,$FF,$DE,$10,$34,$01
	db $01,$FF,$D9,$10,$39,$01
	db $01,$FF,$D1,$10,$41,$01
	db $01,$FF,$D0,$10,$42,$01
	db $01,$FF,$D5,$10,$3D,$01
	

Actions:
    dw DefaultAction
	dw MarioDamage
	

;This routine will be executed when mario interact with a standar hitbox.
;It will be excecuted if $0E is 1 after execute Interaction routine
DefaultAction:
RTS
    
;>End Hitboxes Interaction Section

;>Action
;### Action MarioDamage ###
MarioDamage:
	LDX !SpriteIndex
;Here you can write your action code
SpikyInteraction:
	LDA $1490|!addr	;if player is using the star
	BEQ +			;kill the sprite
	%Star()
	RTS
+
	LDA $187A|!addr	
	BNE +
 
	LDA $140D|!addr
	BEQ +++
+	
	LDA !PlayerYSpeed
	SEC
	SBC !SpriteYSpeed,x
	BMI +++
 
	STZ !ScratchD
	LDA !Scratch3
	STA !ScratchC
 
	LDA !Scratch9
	XBA
	LDA !Scratch1
	REP #$20
	CLC
	ADC !ScratchC
	SEC 
	SBC #$0008
	STA !ScratchC
	SEP #$20
 
	LDA !ScratchB
	XBA
	LDA !Scratch5
	REP #$20
	CMP !ScratchC
	BCC +++
 
 
	PHA
	LDA !ScratchC
	SEC
	SBC $01,s
	ADC #$0008
	STA !ScratchC
	PLA
 
	LDA !PlayerY
	SEC
	SBC !ScratchC
	STA !PlayerY
 
	SEP #$20
 
	JSL $01AB99|!rom
	JSL $01AA33|!rom
 
	LDA #$02
	STA $1DF9|!addr
 
	RTS
+++
	SEP #$20
	PHX
 
	LDA $187A|!addr
	BEQ +
	JSR FindYoshi
	BCC +
	JSR DismountYoshi
	PLX
RTS
+
	JSL $00F5B7|!rom
	PLX
RTS
 
FindYoshi:
	LDX $18DF|!addr
	BEQ .crawlForYoshi
	DEX
	BRA .found
.crawlForYoshi:
	LDX.w $1692|!addr
	; Start Slot according to sprite data
	LDA.l $02A773|!rom,x
	SEC
	SBC #$FE ; spaces 2 reserved slots, have to interact with them too
	TAX
.loop:
	LDA !SpriteNumber,x
	CMP #$35
	BNE .continueLoop
 
	LDA !SpriteStatus,x
	BNE .found
.continueLoop
	DEX
	BPL .loop
.returnClear:
	CLC
	RTS
.found
	SEC
	RTS
 
DismountYoshi:
	LDA #$10                
	STA !SpriteDecTimer6,x             
	LDA #$03                ; \ Play sound effect 
	STA $1DFA|!addr         ; / 
	LDA #$13                ; \ Play sound effect 
	STA $1DFC|!addr         ; / 
	LDA #$02                
	STA !SpriteMiscTable3,x     
	STZ $187A|!addr         
	LDA #$C0                
	STA !PlayerYSpeed       
	STZ !PlayerXSpeed       
	%SubHorzPos()       
	LDA XSpeedDismountTable,y       
	STA !SpriteXSpeed,X    
	STZ !SpriteMiscTable10,x             
	STZ !SpriteMiscTable6,X             
	STZ $18AE|!addr               
	STZ $0DC1|!addr      
	LDA #$30                ; \ Mario invincible timer = #$30 
	STA $1497|!addr         ; / 
	JSR CODE_01EDCC         
RTS                       ; Return 
 
XSpeedDismountTable:
	db $E8,$18
 
CODE_01EDCC:
	LDY.B #$00                
	LDA !SpriteYLow,X       
	SEC                       
	SBC YoshiOffset,Y       
	STA !PlayerY         
	STA $D3                   
	LDA !SpriteYHigh,X     
	SBC #$00                
	STA !PlayerY+$01       
	STA $D4                   
RTS                       ; Return 
 
YoshiOffset:
	db $04,$10
RTS
;>End Action
